
// FDExtRenderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FDExtRender.h"
#include "FDExtRenderDlg.h"
#define _USE_MATH_DEFINES 
#include <math.h>
#include "SCTE104Data.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const long cAliveStep = 1000;
const long cVBILine = 16;

// CFDExtRenderDlg dialog
CFDExtRenderDlg::CFDExtRenderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFDExtRenderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pImage = NULL;
	m_pAudioData = NULL;
	m_hFrameEvent = NULL;
}

void CFDExtRenderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVICE, m_DeviceList);
	DDX_Control(pDX, IDC_DELAY, m_DelayList);
	DDX_Control(pDX, IDC_10BIT_VIDEO, m_10bitVideo);
	DDX_Control(pDX, IDC_10BIT_VBI, m_10bitVBI);
	DDX_Control(pDX, IDC_FRAMES, m_DelayInfo);
	DDX_Control(pDX, IDC_INFO, m_PlayInfo);
}

BEGIN_MESSAGE_MAP(CFDExtRenderDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, &CFDExtRenderDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CFDExtRenderDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_10BIT_VIDEO, &CFDExtRenderDlg::OnBnClicked10bitVideo)
	ON_BN_CLICKED(IDC_10BIT_VBI, &CFDExtRenderDlg::OnBnClicked10bitVBI)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CFDExtRenderDlg message handlers

BOOL CFDExtRenderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	if( Init() != S_OK ) {
		EndDialog(IDCANCEL);
	}
	m_DeviceList.SetCurSel(0);
	m_DelayList.AddString(_T("50ms"));
	m_DelayList.AddString(_T("100ms"));
	m_DelayList.AddString(_T("150ms"));
	m_DelayList.AddString(_T("200ms"));
	m_DelayList.AddString(_T("250ms"));
	m_DelayList.SetCurSel(1);
	m_DelayInfo.SetWindowTextW(_T(""));
	m_10bitVideo.SetCheck(m_bUse10bit4Video ? BST_CHECKED : BST_UNCHECKED);
	m_10bitVBI.SetCheck(m_bUse10bit4VBI ? BST_CHECKED : BST_UNCHECKED);
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFDExtRenderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CDialog dlgAbout(IDD_ABOUTBOX);
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFDExtRenderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFDExtRenderDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CFDExtRenderDlg::OnBnClickedStart()
{
	if( Start()==S_OK ) {
		m_DelayList.EnableWindow(FALSE);
		GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
		GetDlgItem(IDC_START)->EnableWindow(FALSE);
	} else  Stop();
}

void CFDExtRenderDlg::OnBnClickedStop()
{
	Stop();
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
	m_DelayList.EnableWindow(TRUE);
}

//
// -------------- FDExtSrvd usage -------------
//
HRESULT CFDExtRenderDlg::Init()
{
	// clear all
	m_nRenderCnt = 0;
	m_pIPlayer = NULL;
	m_pVBI = NULL;
	m_pIMgr = NULL;
	// create FDExt manager
	HRESULT hres = m_pIMgr.CoCreateInstance(FDExtSrvdLib::CLSID_FDExtMgr);
	ATLASSERT(hres==S_OK);
	// scan all valid renderers
	long nCnt = 0;
	hres = m_pIMgr->get_FDObjectsCount(&nCnt);
	ATLASSERT(hres==S_OK);
	for( long nIndex=0; nIndex < nCnt; nIndex++ ) {
		FDExtSrvdLib::CFDObjectInfo info;
		hres = m_pIMgr->get_FDObjectInfoByIndex(nIndex,&info);
		ATLASSERT(hres==S_OK);
		if( info.m_FDObjType==FDExtSrvdLib::FDObjType_VideoOut && info.m_Valid==TRUE ) {
			// it is a valid renderer - use the device
			long n = m_nRenderCnt++;
			m_nRenderID[n] = nIndex;
			CString sName = CString((WCHAR*)info.m_BoardName) + CString(_T(" ")) + CString((WCHAR*)info.m_FDObjFriendlyName);
			m_DeviceList.AddString(sName);
		}
	}
	if( m_nRenderCnt==0 ) { // no devices - show warning message
		MessageBox(_T("There is no video renderer!\n\nTurn off 'Title mixer' and try again"));
		return S_FALSE;
	}
	return S_OK;
}

HRESULT CFDExtRenderDlg::Start()
{
	m_nDropFrames = 0;
	m_nWarnFrames = 0;
	m_PlayInfo.SetWindowText(_T("No drops"));
	// open video player by index
	int n = m_DeviceList.GetCurSel();
	ATLASSERT(n >= 0 && n < m_nRenderCnt);
	CComPtr<IUnknown> pIUnk;
	HRESULT hres = m_pIMgr->get_FDObjectByIndex(m_nRenderID[n], FDExtSrvdLib::FDObjType_VideoOut, &pIUnk);
	ATLASSERT(hres==S_OK);
	hres = pIUnk->QueryInterface(&m_pIPlayer);
	ATLASSERT(hres==S_OK);
	// obtain VBI interface
	hres = m_pIPlayer->QueryInterface(&m_pVBI);
	ATLASSERT(hres == S_OK);
	// obtain video info of the player
	FDExtSrvdLib::CBoardVideoParams vinfo;
	hres = m_pIPlayer->FDGetVideoParams(&vinfo);
	ATLASSERT(hres == S_OK);
	m_nDX = vinfo.m_DX;
	m_bYOnlyVBI = vinfo.m_DY > 600; // SD fromat use VBI as UYVY !!! all other (HD, 3G...) use VBI into Y line only
	if (vinfo.m_LowerFieldTimerShift < 0.001 && vinfo.m_UpperFieldTimerShift < 0.001) {
		// progressive video - draw by frame
		m_bProgressive = true;
		m_bUpperFieldFirst = true;
		m_nDY = vinfo.m_DY;
	} else {
		// interlaced video - draw by frame
		m_bProgressive = false;
		m_bUpperFieldFirst = vinfo.m_UpperFirst != 0;
		m_nDY = vinfo.m_DY / 2;
	}
	// obtain preffered video format
	FDExtSrvdLib::CFDCaptureVideoFormat vfmt = FDExtSrvdLib::FDCaptureVideoFormat_UYVY;
	FDExtSrvdLib::CFDCaptureSoundFormat afmt = FDExtSrvdLib::FDCaptureSoundFormat_IEEEFloat;
	hres = m_pIPlayer->FDGetPreferredFormats(&vfmt, &afmt);
	ATLASSERT(hres == S_OK);
	if (FDExtSrvdLib::FDCaptureVideoFormat_Y210 == vfmt) {
		m_10bitVideo.EnableWindow(TRUE);
	} else {
		m_bUse10bit4Video = false;
		m_10bitVideo.SetCheck(BST_UNCHECKED);
		m_10bitVideo.EnableWindow(FALSE);
	}
	// obtain VBI info
	hres = m_pIPlayer->FDAllocateVideoFrame(0, 0);
	ATLASSERT(hres == S_OK);
	long nH[2], nUse10bits = FALSE;
	m_nVBIWidth = vinfo.m_DX;
	hres = m_pVBI->FDGetVBILinesSizes(&m_nVBIWidth, &nH[0], &nH[1], &nUse10bits);
	ATLASSERT(hres == S_OK);
	m_nVBIline = cVBILine;
	if (nH[0] <= m_nVBIline)
		m_nVBIline = nH[0] - 1;
	if (!m_bProgressive && nH[1] <= m_nVBIline)
		m_nVBIline = nH[1] - 1;
	ATLASSERT(m_nVBIline >= 0);
	if (FALSE != nUse10bits) {
		m_10bitVBI.EnableWindow(TRUE);
	} else {
		m_bUse10bit4VBI = false;
		m_10bitVBI.SetCheck(BST_UNCHECKED);
		m_10bitVBI.EnableWindow(FALSE);
	}
	m_10bitVBI.ShowWindow(m_nVBIline < 0 ? SW_HIDE : SW_SHOW);
	// create buffer for one image in UYVY 10-bit format
	if(m_pImage != NULL )  delete[] m_pImage;
	m_pImage = new BYTE[m_nDX * m_nDY * 2 * 2];
	ATLASSERT(m_pImage != NULL);
	// we will generate moving black & white stripe, reset stripe position
	m_nOffset = 0;
	// obtain audio info
	FDExtSrvdLib::CBoardSoundParams ainfo;
	hres = m_pIPlayer->FDGetSoundParams(&ainfo);
	ATLASSERT(hres==S_OK);
	// we will play audio from prerender audio buffer with 2 seconds of sin()
	m_fSamplePerFrame = (double)ainfo.m_SampleRate / ainfo.m_FrameRate;
	m_nSampleSize = ainfo.m_Channels * 2;
	m_nSampleAlign = ainfo.m_SampleRate;
	m_nChMask = 0;
	for( int i=0; i<ainfo.m_Channels; i++ )  m_nChMask |= 1<<i;
	// allocate 2 seconds audio data in 16 bit format
	if( m_pAudioData != NULL )  delete[] m_pAudioData;
	m_pAudioData = new short[ainfo.m_SampleRate * ainfo.m_Channels * 2];
	ATLASSERT(m_pAudioData != NULL);
	// reset audio playback position
	m_nLocalFrameIndex = 0; // local frame index (starting from zero)
	// fill 2 seconds of audio data by sin(400Hz)
	int nFreq = 400;
	int nPeriod = ainfo.m_SampleRate / nFreq;
	short *ptr = m_pAudioData;
	for( int i=0; i<nPeriod; i++ ) {
		short v = (short)(0x7FFF * sin(M_PI * (2*i) / nPeriod));
		for( int i=0; i<ainfo.m_Channels; i++ )  *ptr++ = v;
	}
	for( int i=1; i<nFreq*2; i++ )  CopyMemory(&m_pAudioData[i*nPeriod*ainfo.m_Channels], m_pAudioData, nPeriod*ainfo.m_Channels*2);
	// obtain fifo fullness/delay in frames (for 200ms delay)
	m_nFullness = (long)(vinfo.m_FrameRate * 0.050 * (m_DelayList.GetCurSel() + 1) + 0.499);
	if (m_nFullness < 3)  m_nFullness = 3;
	CString str;  
	str.Format(_T("(%d frames)"), m_nFullness);
	m_DelayInfo.SetWindowText(str);
	// open event for frame sync
	CComQIPtr<FDExtSrvdLib::IFDExtMgrAVObjectsInfo2> pInfo2(m_pIMgr);
	CComBSTR bstr;
	hres = pInfo2->get_ObjectFieldEventName(m_nRenderID[n], &bstr);
	ATLASSERT(hres == S_OK);
	m_hFrameEvent = OpenEvent(SYNCHRONIZE, FALSE, (LPCWSTR)bstr);
	ATLASSERT(m_hFrameEvent != NULL);
	// obtain current time
	DWORD64 tmp;
	hres = m_pIPlayer->FDGetBoardTime(&m_nFrameIndex,&tmp);
	ATLASSERT(hres==S_OK);
	// start render few frames later (as fifo fullness)
	m_nFrameIndex += m_nFullness;
	// start playback
	m_bSuicide = false;
	m_threadWait = std::thread([=] { RenderLoop(); });
	return S_OK;
}

HRESULT CFDExtRenderDlg::Stop()
{
	m_bSuicide = true;
	if (m_threadWait.joinable())  m_threadWait.join();
	m_pIPlayer = NULL;
	m_pVBI = NULL;
	if(m_pImage != NULL ) {
		delete[] m_pImage;
		m_pImage = NULL;
	}
	if( m_pAudioData != NULL ) {
		delete[] m_pAudioData;
		m_pAudioData = NULL;
	}
	if (m_hFrameEvent != NULL) {
		CloseHandle(m_hFrameEvent);
		m_hFrameEvent = NULL;
	}
	return S_OK;
}

void CFDExtRenderDlg::RenderLoop()
{
	while (!m_bSuicide) {
		if (RenderFrame() != S_OK)
			WaitForSingleObject(m_hFrameEvent, 10);
	}
}

HRESULT CFDExtRenderDlg::RenderFrame()
{
	// check current time
	DWORD64 nFrame,nTime;
	HRESULT hres = m_pIPlayer->FDGetBoardTime(&nFrame,&nTime);
	ATLASSERT(hres==S_OK);
	if( m_nFrameIndex > nFrame+m_nFullness) // fifo is full - wait
		return S_FALSE;
	if (m_nFrameIndex < nFrame + 1) { // fifo underrun !!! skip frames
		long nSkip = (long)(nFrame+2 - m_nFrameIndex);
		m_nFrameIndex += nSkip;
		m_nLocalFrameIndex += nSkip;
		m_nDropFrames += nSkip;
		CString str;
		str.Format(_T("Drop %d frames, Warning about %d frames"), m_nDropFrames, m_nWarnFrames);
		m_PlayInfo.SetWindowText(str);
	}
	else if(m_nFrameIndex - nFrame <= 2) {
		m_nWarnFrames++;
		CString str;
		str.Format(_T("Drop %d frames, Warning about %d frames"), m_nDropFrames, m_nWarnFrames);
		m_PlayInfo.SetWindowText(str);
	}
	hres = m_pIPlayer->FDAllocateVideoFrame(m_nFrameIndex,0);
	if( hres != S_OK )
		return hres;
	// fill audio
	DWORD64 nCurAudioSample = (DWORD64)(m_fSamplePerFrame*m_nLocalFrameIndex + 0.5);
	DWORD64 nNextAudioSample = (DWORD64)(m_fSamplePerFrame*(m_nLocalFrameIndex+1) + 0.5);
	long size = (long)(nNextAudioSample - nCurAudioSample) * m_nSampleSize;
	long offset = (nCurAudioSample % m_nSampleAlign) * m_nSampleSize;
	// copy audio into fifo
	hres = m_pIPlayer->FDWriteSoundData((BYTE*)m_pAudioData + offset,size, FDExtSrvdLib::FDCaptureSoundFormat_16bit, m_nChMask);
	ATLASSERT(hres==S_OK);
	// fill video
	if (m_bProgressive) {
		long pos = (long)(m_nLocalFrameIndex % m_nDX);
		if (m_bUse10bit4Video) {
			hres = FillFrame10(pos);
			ATLASSERT(hres == S_OK);
		} else {
			hres = FillFrame8(pos);
			ATLASSERT(hres == S_OK);
		}
	} else {
		long pos = (long)(m_nLocalFrameIndex % (m_nDX / 2)) * 2;
		if (m_bUse10bit4Video) {
			hres = FillField10(m_bUpperFieldFirst ? TRUE : FALSE, pos);
			ATLASSERT(hres == S_OK);
			hres = FillField10(m_bUpperFieldFirst ? FALSE : TRUE, pos + 1);
			ATLASSERT(hres == S_OK);
		} else {
			hres = FillField8(m_bUpperFieldFirst ? TRUE : FALSE, pos);
			ATLASSERT(hres == S_OK);
			hres = FillField8(m_bUpperFieldFirst ? FALSE : TRUE, pos + 1);
			ATLASSERT(hres == S_OK);
		}
	}
	// fill VBI
	if (m_nVBIline >= 0) {
		if (m_bProgressive) {
			if (m_bUse10bit4VBI) {
				hres = FillVBI10(TRUE, m_nLocalFrameIndex);
				ATLASSERT(hres == S_OK);
			} else {
				hres = FillVBI8(TRUE, m_nLocalFrameIndex);
				ATLASSERT(hres == S_OK);
			}
		} else {
			if (m_bUse10bit4VBI) {
				hres = FillVBI10(m_bUpperFieldFirst ? TRUE : FALSE, m_nLocalFrameIndex * 2 + 0);
				ATLASSERT(hres == S_OK);
				hres = FillVBI10(m_bUpperFieldFirst ? FALSE : TRUE, m_nLocalFrameIndex * 2 + 1);
				ATLASSERT(hres == S_OK);
			} else {
				hres = FillVBI8(m_bUpperFieldFirst ? TRUE : FALSE, m_nLocalFrameIndex * 2 + 0);
				ATLASSERT(hres == S_OK);
				hres = FillVBI8(m_bUpperFieldFirst ? FALSE : TRUE, m_nLocalFrameIndex * 2 + 1);
				ATLASSERT(hres == S_OK);
			}
		}
	}
	// mark frame as ready
	hres = m_pIPlayer->FDConfirmFrame();
	if( hres==S_FALSE ) // current frame already played - try again new one
		return S_OK;
	ATLASSERT(hres==S_OK);
	// goto next frame
	m_nLocalFrameIndex++;
	m_nFrameIndex++;
	return S_OK;
}

HRESULT CFDExtRenderDlg::FillFrame8(long offset)
{
	// fill 8-bit image UYVY
	BYTE *ptr = m_pImage;
	for (int x = 0; x < m_nDX; x++) {
		ptr[x * 2 + 0] = 0x80; // U/V
		ptr[x * 2 + 1] = x < offset ? 16 : 235; // Y
	}
	int stride = m_nDX * 2;
	for (int y = 1; y < m_nDY; y++) {
		ptr += stride;
		CopyMemory(ptr, m_pImage, stride);
	}
	// copy video into fifo
	HRESULT hres = m_pIPlayer->FDWriteVideoFrameData(m_pImage, stride * m_nDY, stride, FDExtSrvdLib::FDCaptureVideoFormat_UYVY);
	ATLASSERT(hres == S_OK);
	return S_OK;
}

HRESULT CFDExtRenderDlg::FillField8(BOOL bUpperField, long offset)
{
	// fill 8-bit image UYVY
	BYTE *ptr = m_pImage;
	for (int x = 0; x < m_nDX; x++) {
		ptr[x * 2 + 0] = 0x80; // U/V
		ptr[x * 2 + 1] = x < offset ? 16 : 235; // Y
	}
	int stride = m_nDX * 2;
	for (int y = 1; y < m_nDY; y++) {
		ptr += stride;
		CopyMemory(ptr, m_pImage, stride);
	}
	// copy video into fifo
	HRESULT hres = m_pIPlayer->FDWriteVideoFieldData(m_pImage, stride * m_nDY, stride, FDExtSrvdLib::FDCaptureVideoFormat_UYVY, bUpperField);
	ATLASSERT(hres == S_OK);
	return S_OK;
}

HRESULT CFDExtRenderDlg::FillVBI8(BOOL bUpperField, long nIndex)
{
	if (NULL == m_pVBI || nIndex % cAliveStep != 0)
		return S_OK;
	// clear local buffer
	BYTE *to = m_pImage;
	for (int x = 0; x < m_nVBIWidth; x++) {
		to[2 * x + 0] = 0x80; // U/V
		to[2 * x + 0] = 0x10; // Y
	}
	// fill SCTE104 message 'Alive'
	FILETIME ft;
	GetSystemTimePreciseAsFileTime(&ft);
	CAliveRequest msg;
	msg.Fill((BYTE)(nIndex / cAliveStep), *(DWORD64*)&ft);
	SDIPacketHeaderPlus hd(sizeof(msg));
	// fill SDI packet for VBI data
	BYTE packet[sizeof(hd) + sizeof(msg) + 1];
	CopyMemory(&packet[0], &hd, sizeof(hd));
	CopyMemory(&packet[sizeof(hd)], &msg, sizeof(msg));
	packet[sizeof(hd) + sizeof(msg)] = 0; // driver will calculate control sum automatically (for 8-bit data)
	// copy message to local buffer
	UINT cnt;
	if (m_bYOnlyVBI) {
		// copy packet to Y line only (HD/3G/4K standard)
		for (int i = 0; i < sizeof(packet); i++)  m_pImage[i * 2 + 1] = packet[i];
		cnt = sizeof(packet) * 2;
	} else {
		// copy data as UYVY (SD standard)
		CopyMemory(m_pImage, packet, sizeof(packet));
		cnt = (sizeof(packet) + 1) & ~1;
	}
	// copy VBI into fifo
	HRESULT hres = m_pVBI->FDWriteVBILineData(m_pImage, cnt, FDExtSrvdLib::tag_CVBIDataFormat::VBIDataFormat_UYVY_8, m_nVBIline, bUpperField);
	ATLASSERT(hres == S_OK);
	return S_OK;
}


HRESULT CFDExtRenderDlg::FillFrame10(long offset)
{
	// fill 10-bit image (FDCaptureVideoFormat_Y210)
	WORD *data = (WORD*)m_pImage;
	for (int x = 0; x < m_nDX; x++) {
		data[x * 2 + 0] = x < offset ? 0x1000 : 0xEB00; // Y = 16 or 235
		data[x * 2 + 1] = 0x8000; // U/V = 0x80
	}
	int stride = m_nDX * 4;
	BYTE *ptr = m_pImage;
	for (int y = 1; y < m_nDY; y++) {
		ptr += stride;
		CopyMemory(ptr, m_pImage,stride);
	}
	// copy video into fifo
	HRESULT hres = m_pIPlayer->FDWriteVideoFrameData(m_pImage, stride * m_nDY, stride, FDExtSrvdLib::FDCaptureVideoFormat_Y210);
	ATLASSERT(hres==S_OK);
	return S_OK;
}

HRESULT CFDExtRenderDlg::FillField10(BOOL bUpperField, long offset)
{
	// fill 10-bit image (FDCaptureVideoFormat_Y210)
	WORD *data = (WORD*)m_pImage;
	for (int x = 0; x < m_nDX; x++) {
		data[x * 2 + 0] = x < offset ? 0x1000 : 0xEB00; // Y = 16 or 235
		data[x * 2 + 1] = 0x8000; // U/V = 0x80
	}
	int stride = m_nDX * 4;
	BYTE *ptr = m_pImage;
	for (int y = 1; y < m_nDY; y++) {
		ptr += stride;
		CopyMemory(ptr, m_pImage, stride);
	}
	// copy video into fifo
	HRESULT hres = m_pIPlayer->FDWriteVideoFieldData(m_pImage, stride * m_nDY, stride, FDExtSrvdLib::FDCaptureVideoFormat_Y210, bUpperField);
	ATLASSERT(hres == S_OK);
	return S_OK;
}

// convert 8-bit SDI packet data to 10-bit (output range = [0x000 .. 0x3FF])
inline USHORT Convert8to10bits(BYTE v)
{
	USHORT v10 = 0x200;

	if (v & 0x01)	v10 ^= 0x300;
	if (v & 0x02)	v10 ^= 0x300;
	if (v & 0x04)	v10 ^= 0x300;
	if (v & 0x08)	v10 ^= 0x300;
	if (v & 0x10)	v10 ^= 0x300;
	if (v & 0x20)	v10 ^= 0x300;
	if (v & 0x40)	v10 ^= 0x300;
	if (v & 0x80)	v10 ^= 0x300;

	return v10 + v;
}

inline WORD ConvertCheckSum9to10(WORD v)
{
	v = v & 0x1ff;
	return (v & 0x100) == 0 ? v | 0x200 : v;
}

inline bool ConvertSDIPacket8to10(BYTE *from, UINT max_from_size, WORD *to, UINT to_step)
{
	// check packet header
	if (0x00 != from[0] || 0xFF != from[1] || 0xFF != from[2])
		return false;
	// obtain total length
	UINT ln = from[5] + 7;
	if (ln > max_from_size)
		return false;
	// write packet header
	to[0 * to_step] = 0x000;
	to[1 * to_step] = 0x3FF;
	to[2 * to_step] = 0x3FF;
	WORD sum = 0;
	for (UINT i = 3; i < ln - 1; i++) {
		WORD v = Convert8to10bits(from[i]);
		to[i * to_step] = v;
		sum += v;
	}
	to[(ln - 1) * to_step] = ConvertCheckSum9to10(sum);
	return true;
}

HRESULT CFDExtRenderDlg::FillVBI10(BOOL bUpperField, long nIndex)
{
	if (NULL == m_pVBI || nIndex % cAliveStep != 0)
		return S_OK;
	// clear local buffer
	WORD *to = (WORD*)m_pImage;
	for (int x = 0; x < m_nVBIWidth; x++) {
		to[x * 2 + 0] = 0x1000; // Y = 16
		to[x * 2 + 1] = 0x8000; // U/V = 0x80
	}
	// fill SCTE104 message 'Alive'
	FILETIME ft;
	GetSystemTimePreciseAsFileTime(&ft);
	CAliveRequest msg;
	msg.Fill((BYTE)(nIndex / cAliveStep), *(DWORD64*)&ft);
	SDIPacketHeaderPlus hd(sizeof(msg));
	// fill SDI packet for VBI data
	BYTE packet[sizeof(hd) + sizeof(msg) + 1];
	CopyMemory(&packet[0], &hd, sizeof(hd));
	CopyMemory(&packet[sizeof(hd)], &msg, sizeof(msg));
	packet[sizeof(hd) + sizeof(msg)] = 0; // driver will calculate control sum automatically (for 8-bit data)
	// copy message to local buffer
	UINT cnt;
	if (m_bYOnlyVBI) {
		// copy packet to Y line only (HD/3G/4K standard)
		bool res = ConvertSDIPacket8to10(packet, m_nVBIWidth / 2, to, 2);
		ATLASSERT(res);
		cnt = sizeof(packet) * 2;
		for (UINT i = 0; i < cnt; i += 2)  to[i] <<= 6;
	} else {
		// copy data as UYVY (SD standard)
		bool res = ConvertSDIPacket8to10(packet, m_nVBIWidth / 2, to, 1);
		ATLASSERT(res);
		cnt = (sizeof(packet) + 1) & ~1;
		for (UINT i = 0; i < cnt; i++)  to[i] <<= 6;
	}
	// copy VBI into fifo
	HRESULT hres = m_pVBI->FDWriteVBILineData(m_pImage, cnt*2, FDExtSrvdLib::tag_CVBIDataFormat::VBIDataFormat_Y210, m_nVBIline, bUpperField);
	ATLASSERT(hres == S_OK);
	return S_OK;
}
