
// FDExtRenderDlg.h : header file
//

#pragma once
#include "afxwin.h"

#include <thread>

// CFDExtRenderDlg dialog
class CFDExtRenderDlg : public CDialog
{
// Construction
public:
	CFDExtRenderDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_FDEXTRENDER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	CComboBox m_DeviceList;
	CComboBox m_DelayList;
	CButton m_10bitVideo;
	CButton m_10bitVBI;
	CStatic m_DelayInfo;
	CStatic m_PlayInfo;
	enum { eMaxDeviceNumber=16 };
	long m_nRenderID[eMaxDeviceNumber];
	long m_nRenderCnt;
	CComPtr<FDExtSrvdLib::IFDExtMgr> m_pIMgr;
	CComPtr<FDExtSrvdLib::IFDVideoOut> m_pIPlayer;
	CComPtr<FDExtSrvdLib::IFDVideoOutVBI> m_pVBI;
	DWORD64 m_nFrameIndex;
	bool m_bProgressive;
	bool m_bUpperFieldFirst;
	long m_nDX,m_nDY,m_nOffset;
	BYTE *m_pImage;
	double m_fSamplePerFrame;
	long m_nSampleAlign,m_nSampleSize,m_nChMask;
	short *m_pAudioData;
	long m_nLocalFrameIndex;
	long m_nDropFrames;
	long m_nWarnFrames;
	volatile bool m_bUse10bit4Video = true;
	volatile bool m_bUse10bit4VBI = true;
	long m_nVBIWidth;
	bool m_bYOnlyVBI;
	long m_nVBIline;
	HANDLE m_hFrameEvent;
	std::thread m_threadWait;
	volatile bool m_bSuicide;
	long m_nFullness;

protected:
	HRESULT Init();
	HRESULT Start();
	HRESULT Stop();
	void Update10bit(CButton &btn, volatile bool &bUse) { bUse = btn.GetCheck() == BST_CHECKED; }
	void RenderLoop();
	HRESULT RenderFrame();
	HRESULT FillFrame8(long offset);
	HRESULT FillField8(BOOL bUpperField, long offset);
	HRESULT FillVBI8(BOOL bUpperField, long nIndex);
	HRESULT FillFrame10(long offset);
	HRESULT FillField10(BOOL bUpperField, long offset);
	HRESULT FillVBI10(BOOL bUpperField, long nIndex);

public:
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedStart();
	afx_msg void OnBnClickedStop();
	afx_msg void OnBnClicked10bitVideo() { Update10bit(m_10bitVideo, m_bUse10bit4Video); }
	afx_msg void OnBnClicked10bitVBI() { Update10bit(m_10bitVBI, m_bUse10bit4VBI); }
};
